/// <reference types="node" />
import { BigNumber } from "bignumber.js";
import BN = require("bn.js");
export declare class Bitstream {
    private initialData;
    private data;
    constructor(initialData?: string);
    getData(): string;
    getBytes32Array(): string[];
    addBigNumber(x: BigNumber, numBytes?: number, forceAppend?: boolean): number;
    addBN(x: BN, numBytes?: number, forceAppend?: boolean): number;
    addNumber(x: number, numBytes?: number, forceAppend?: boolean): number;
    addAddress(x: string, numBytes?: number, forceAppend?: boolean): number;
    addHex(x: string, forceAppend?: boolean): number;
    addRawBytes(bs: string, forceAppend?: boolean): number;
    extractUint8(offset: number): number;
    extractUint16(offset: number): number;
    extractUint32(offset: number): number;
    extractUint(offset: number): BigNumber;
    extractAddress(offset: number): string;
    extractBytes1(offset: number): Buffer;
    extractBytes32(offset: number): Buffer;
    extractBytesX(offset: number, length: number): Buffer;
    length(): number;
    private insert(x, forceAppend);
    private padString(x, targetLength);
}
