import { Context } from "./context";
import { Mining } from "./mining";
import { OrderInfo } from "./types";
export declare class ExchangeDeserializer {
    private context;
    private data;
    private spendableList?;
    private dataOffset;
    private tableOffset;
    private zeroBytes32;
    constructor(context: Context);
    deserialize(data: string): [Mining, OrderInfo[], number[][]];
    private setupMiningData(tablesPtr);
    private setupOrders(tablesPtr, numOrders);
    private assembleOrder();
    private assembleRings(numRings, offset, orders);
    private assembleRing(ringSize, offset, orders);
    private getNextOffset();
    private nextAddress();
    private nextUint();
    private nextUint16();
    private nextUint32();
    private nextBytes();
    private nextBytes32();
    private toInt16(x);
    private validateSpendables(orders);
}
