"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function expectThrow(promise, expectedRevertMessage) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield promise;
        }
        catch (error) {
            if (expectedRevertMessage) {
                const message = error.message.search(expectedRevertMessage) >= 0;
                assert(message, "Expected throw with message " + expectedRevertMessage + ", got '" + error + "' instead");
            }
            else {
                const revert = error.message.search("revert") >= 0;
                const invalidOpcode = error.message.search("invalid opcode") >= 0;
                assert(revert || invalidOpcode, "Expected throw, got '" + error + "' instead");
            }
            return;
        }
        assert.fail("Expected throw not received");
    });
}
exports.expectThrow = expectThrow;
//# sourceMappingURL=expectThrow.js.map