"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const protocol_simulator_1 = require("./protocol_simulator");
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const args = process.argv.slice(2);
        console.log("args:", args);
        if (args.length < 2) {
            throw new Error("error: not enough params.");
        }
        const fileName = args[1];
        const fileContent = fs.readFileSync(fileName, "utf8");
        if (args[0] === "--decode-param") {
            try {
                const paramInfo = JSON.parse(fileContent);
                console.log(paramInfo);
                const protocolSimulator = new protocol_simulator_1.ProtocolSimulator(undefined);
                const ringsInfo = protocolSimulator.deserialize(paramInfo.bs, paramInfo.txOrigin);
                console.log("deserialized ringsInfo: ", ringsInfo);
            }
            catch (err) {
                console.log(err);
            }
        }
        else if (args[0] === "--encode-rings") {
            let ringsInfo;
            ringsInfo = JSON.parse(fileContent);
            console.log("ringsInfo:", ringsInfo);
            throw new Error("Not implemented yet.");
            // const report = await protocolSimulator.simulateAndReport(ringsInfo);
        }
        else if (args[0] === "--decode-simulate") {
            try {
                const paramInfo = JSON.parse(fileContent);
                const protocolSimulator = new protocol_simulator_1.ProtocolSimulator(undefined);
                const ringsInfo = protocolSimulator.deserialize(paramInfo.bs, paramInfo.txOrigin);
                console.log("deserialized ringsInfo: ", ringsInfo);
            }
            catch (err) {
                console.log(err);
            }
        }
        else {
            throw new Error("error: invalid argument:" + args);
        }
    });
}
main();
//# sourceMappingURL=main.js.map