/// <reference types="node" />
import Web3 = require("web3");
import { OrderInfo, SignAlgorithm } from "./types";
export declare class MultiHashUtil {
    web3Instance: Web3;
    constructor();
    signOrderAsync(order: OrderInfo): Promise<string>;
    signAsync(algorithm: SignAlgorithm, hash: Buffer, address: string, privateKey?: string): Promise<string>;
    verifySignature(signer: string, hash: Buffer, multihash: string): boolean;
    private signEthereumAsync(sig, hash, privateKey);
    private signEIP712Async(sig, hash, privateKey);
}
