"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Make sure to keep this in sync with the Multihash smart contract
var SignAlgorithm;
(function (SignAlgorithm) {
    SignAlgorithm[SignAlgorithm["Ethereum"] = 0] = "Ethereum";
    // Should be compatible with Trezor now (with latest firmware):
    // https://github.com/ethereum/go-ethereum/issues/14794#issuecomment-392028942
    SignAlgorithm[SignAlgorithm["EIP712"] = 1] = "EIP712";
    // EIP712: https://github.com/ethereum/EIPs/blob/master/EIPS/eip-712.md
    SignAlgorithm[SignAlgorithm["None"] = 255] = "None";
})(SignAlgorithm = exports.SignAlgorithm || (exports.SignAlgorithm = {}));
var TokenType;
(function (TokenType) {
    TokenType[TokenType["ERC20"] = 0] = "ERC20";
    TokenType[TokenType["COUNT"] = 1] = "COUNT";
})(TokenType = exports.TokenType || (exports.TokenType = {}));
//# sourceMappingURL=types.js.map